//****************************************************************************
writeHexByte:
; d0.b value
; a0 adress to write;
	movem.l	d0-d1/a1,-(a7)
	lea		hex(pc),a1
	move	d0,d1
	and		#$f,d0
	lsr		#4,d1
	and		#$f,d1
	move.b	(a1,d0),1(a0)
	move.b	(a1,d1),(a0)
	movem.l	(a7)+,d0-d1/a1
	rts
writeHexWord:
; d0.w value
; a0 adress to write;
	movem.l	d0-d1/a1,-(a7)
	lea		(a0),a1
	lea		2(a1),a0
	jsr		writeHexByte
	lsr		#8,d0
	lea		(a1),a0
	jsr		writeHexByte
	movem.l	(a7)+,d0-d1/a1
	rts
writeHexLong:
; d0.l value
; a0 adress to write;
	movem.l	d0-d1/a1,-(a7)
	lea		(a0),a1
	lea		4(a1),a0
	jsr		writeHexWord
	swap	d0
	lea		(a1),a0
	jsr		writeHexWord
	movem.l	(a7)+,d0-d1/a1
	rts
//****************************************************************************
clearScreen:
	move.l	phystop,a0
	sub.l	#$8000,a0
	move	#(160*200/4)-1,d0
.clearScreenLoop:
	clr.l 	(a0)+
	dbf		d0,.clearScreenLoop
	rts
//****************************************************************************
printStates:
	lea		state68KText(pc),a0
	move	#14,d0
	move	#11,d1
	bsr		printText

	move	state,d0
	lsl		#4,d0
	ext.l d0
	lea		state68KTexts(pc),a0
	add.l	d0,a0
	move	#14,d0
	move	#12,d1
	bsr		printText
	
	lea		fpgaStateText(pc),a0
	move	#0,d0
	move	#11,d1
	bsr		printText
	rts

//****************************************************************************
printUploadCounter:
;	move	uploadCount,d0
;	lea		lenText(pc),A0
;	bsr		writeHexWord
	
;	move	byteCount,d0
;	lea		lenText+5(pc),A0
;	bsr		writeHexWord
	
	lea		lenText(pc),A0
	move	#0,d0
	move	#13,d1
	bsr		printText
	rts
//****************************************************************************
printText:
; a0 text
; d0 x
; d1 y
; 0 ends text
; 1, adr.l print byte
; 2, adr.l print word
; 3, adr.l print long
; 10 new line
	move.l	phystop,a1
	sub.l	#$8000,a1

	mulu	#160*8,d1
	move	d0,d6
	movem.l	d0-a6,-(a7)
.write
	moveq	#0,d2

	move.b	(a0)+,d2
	beq.b	.end

	cmp.b	#1,d2	;print hex byte
	bne		.printNohexByte
	bsr		printGetLong
	move.l	d4,a2
	move.b	(a2)+,d2
	bsr		printHexByte
	bra.s	.write
.printNohexByte
	cmp.b	#2,d2	;print hex word
	bne		.printNohexWord
	bsr		printGetLong
	move.l	d4,a2
	move.b	(a2)+,d2
	bsr		printHexByte
	move.b	(a2)+,d2
	bsr		printHexByte
	bra.s	.write

.printNohexWord:
	cmp.b	#3,d2	;print hex long
	bne		.printNohexLong
	bsr		printGetLong
	move.l	d4,a2
	move.b	(a2)+,d2
	bsr		printHexByte
	move.b	(a2)+,d2
	bsr		printHexByte
	move.b	(a2)+,d2
	bsr		printHexByte
	move.b	(a2)+,d2
	bsr		printHexByte
	bra.s	.write

.printNohexLong:

	cmp.b	#10,d2
	bne.s	.nonew
	move	d6,d0
	add.w	#160*8,d1
	bra.s	.write
.nonew
	bsr		printChar
	bra.s	.write
.end
	movem.l	(a7)+,d0-a6
	rts
printHexByte:
	move.l	a2,-(a7)
	lea		hex(pc),a2
	move	d2,d4
	and		#$f,d4
	lsr		#4,d2
	and		#$f,d2

	move.b	(a2,d2),d2
	ext.w	d2
	movem.l	a2/d4,-(a7)
	bsr		printChar
	movem.l	(a7)+,a2/d4

	move.b	(a2,d4),d2
	ext.w	d2
	bsr		printChar
	move.l	(a7)+,a2
	rts
printGetLong:
	move.b	(a0)+,d4
	lsl.w	#8,d4
	move.b	(a0)+,d4
	lsl.l	#8,d4
	move.b	(a0)+,d4
	lsl.l	#8,d4
	move.b	(a0)+,d4
	rts
printChar:
	bsr		UDGetVarRamPos

	move.l	fontPosition(a6),a2
	lea		(a2,d2.w),a2
	move 	d0,d4
	move	d0,d5
	and		#$1,d4
	lsr		#1,d5
	lsl		#3,d5
	add		d5,d4
	add		d1,d4
	lea		(a1,d4.w),a3

	move.b	(a2),(a3)
	move.b	256*1(a2),160*1(a3)
	move.b	256*2(a2),160*2(a3)
	move.b	256*3(a2),160*3(a3)
	move.b	256*4(a2),160*4(a3)
	move.b	256*5(a2),160*5(a3)
	move.b	256*6(a2),160*6(a3)
	move.b	256*7(a2),160*7(a3)
	addq.w	#1,d0

	rts