************************************************************
* Project:	ultraDev
* Module:	UDDriveImage
* Code:		ultra
* Created:	25.03.2020
* Notes:	Service routines for accessing a sector based
*			volume.
*			ultraDev.exe must run in server mode to handle
*			sector reads.
* Modified:
* Changes:
*
* (c) 2020 cream
************************************************************

UDDIReadSector:
;-> a0	buffer to read to
;-> d0	sector number
;-> d1	sector count (max. depends on the sector size max 8kb)

;<- if success and done read is readed to a0

.UDDIReadSectorLoop:
	lea		$fb0000,a2
	//set sector number
	move	UDRegWriteToSectorLow,d2

	move	d0,d2
	and		#$ff,d2
	add		d2,d2
	move	(a2,d2),d2

	move	UDRegWriteToSectorHigh,d2

	move	d0,d2
	lsr		#8,d2
	and		#$ff,d2
	add		d2,d2
	move	(a2,d2),d2

	//set sector count (fixed to 1 currently)
	move	UDRegWriteToSectorCount,d2

	moveq	#1,d2
	and		#$ff,d2
	add		d2,d2
	move	(a2,d2),d2

	move	UDDIReadSectorFlag,d2
;	bsr		UDDIWaitBusy
;	tst		d6
;	bpl.s	.UDDIReadSectorOk
;	move	d6,d0
;	rts
;.UDDIReadSectorOk
	
	lea		(a0),a2
	move.l	a2,d7

	btst	#0,d7
	bne		.UDDICopyBytes


	movem.l	d0-d3/a0,-(a7)
	lea		UIDISectorBuffer,a0
	move.l	a2,a1

	move	UDDISectorSize,d0
	lsr		#8,d0
	lsr		#1,d0
	subq	#1,d0

	moveq	#1,d1
.UDDICopySectorL3:
	move.l	$4ba,d3
	add.l	#32,d3
.UDDICopySectorL:
//	move	$4ba,$ffff8240.w
	cmp.l	$4ba,d3
	ble		.UDDIWaitBusyTimeout2

	move	UDDIState,d2
	and		#UDDIStateBusy,d2
	beq.s	.UDDICopySectorL2

	move	$fa4052,d2
	and		d1,d2
	beq.s	.UDDICopySectorL
.UDDICopySectorL2
	move.l	d1,-(a7)	
	movem.l	(a0)+,d1-d7/a2-a6		;48
	movem.l	d1-d7/a2-a6,(a1)

	movem.l	(a0)+,d1-d7/a2-a6		;48
	movem.l	d1-d7/a2-a6,48*1(a1)

	movem.l	(a0)+,d1-d7/a2-a6		;48
	movem.l	d1-d7/a2-a6,48*2(a1)

	movem.l	(a0)+,d1-d7/a2-a6		;48
	movem.l	d1-d7/a2-a6,48*3(a1)

	movem.l	(a0)+,d1-d7/a2-a6		;48
	movem.l	d1-d7/a2-a6,48*4(a1)

	movem.l	(a0)+,d1-d7/a2-a6		;48
	movem.l	d1-d7/a2-a6,48*5(a1)

	movem.l	(a0)+,d1-d7/a2-a6		;48
	movem.l	d1-d7/a2-a6,48*6(a1)

	movem.l	(a0)+,d1-d7/a2-a6		;48
	movem.l	d1-d7/a2-a6,48*7(a1)

	movem.l	(a0)+,d1-d7/a2-a6		;48
	movem.l	d1-d7/a2-a6,48*8(a1)

	movem.l	(a0)+,d1-d7/a2-a6		;48
	movem.l	d1-d7/a2-a6,48*9(a1)

	movem.l	(a0)+,d1-d7/a2		;32
	movem.l	d1-d7/a2,48*10(a1)
	movem.l	(a7)+,d1
	add		d1,d1

	lea		512(a1),a1
	dbf		d0,.UDDICopySectorL3
	movem.l	(a7)+,d0-d3/a0

	bra.s	.UDDIReadNext

.UDDICopyBytes:
	bsr		UDDIWaitBusy
	tst		d6
	bpl.s	.UDDIReadSectorOk2
	move	d6,d0
	rts
.UDDIReadSectorOk2:
	move	UDDISectorSize,d7
	lsr		#4,d7
	subq	#1,d7
	lea		UIDISectorBuffer,a1
.UDDICopySectorB:
	move.b	(a1)+,(a2)+
	move.b	(a1)+,(a2)+
	move.b	(a1)+,(a2)+
	move.b	(a1)+,(a2)+
	move.b	(a1)+,(a2)+
	move.b	(a1)+,(a2)+
	move.b	(a1)+,(a2)+
	move.b	(a1)+,(a2)+
	move.b	(a1)+,(a2)+
	move.b	(a1)+,(a2)+
	move.b	(a1)+,(a2)+
	move.b	(a1)+,(a2)+
	move.b	(a1)+,(a2)+
	move.b	(a1)+,(a2)+
	move.b	(a1)+,(a2)+
	move.b	(a1)+,(a2)+
	dbf		d7,.UDDICopySectorB
.UDDIReadNext:
	move	UDDISectorSize,d7
	lea		(a0,d7.w),a0

	addq	#1,d0
	subq	#1,d1
	bne		.UDDIReadSectorLoop
	moveq	#0,d0
	rts

.UDDIWaitBusyTimeout2:
	movem.l	(a7)+,d0-d3/a0
	moveq	#-2,d0		; E_DRVNR
	rts
************************************************************
UDDIWaitBusy:
	move.l	$4ba,d3
	add.l	#32,d3
UDDIWaitBusyLoop:
;	move	$4bc,$ffff8240.w
	cmp.l	$4ba,d3
	ble.s	UDDIWaitBusyTimeout
	move	UDDIState,d2
	and		#UDDIStateBusy,d2
	bne.s	UDDIWaitBusyLoop
	moveq	#0,d6
	rts
UDDIWaitBusyTimeout:
	moveq	#-2,d6		; E_DRVNR
	rts
************************************************************
UDDIWriteHdvLong:
	lea		$fb0000,a2

	move	d0,d2
	and		#$ff,d2
	add		d2,d2
	move	(a2,d2),d2

	lsr.l	#8,d0
	move	d0,d2
	and		#$ff,d2
	add		d2,d2
	move	(a2,d2),d2

	lsr.l	#8,d0
	move	d0,d2
	and		#$ff,d2
	add		d2,d2
	move	(a2,d2),d2

	lsr.l	#8,d0
	move	d0,d2
	and		#$ff,d2
	add		d2,d2
	move	(a2,d2),d2
	rts

